## pytorch-cluster 1.6.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(torchcluster)
set(CMAKE_CXX_STANDARD 14)
set(TORCHCLUSTER_VERSION 1.6.3)

option(WITH_CUDA "Enable CUDA support" OFF)
option(WITH_PYTHON "Link to Python when building" ON)

if(WITH_CUDA)
  enable_language(CUDA)
  add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
  add_definitions(-DWITH_CUDA)
  set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
endif()

if (WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  find_package(Python3 COMPONENTS Development)
endif()
find_package(Torch REQUIRED)

file(GLOB HEADERS csrc/*.h)
file(GLOB OPERATOR_SOURCES csrc/*.* csrc/cpu/*.*)
if(WITH_CUDA)
  file(GLOB OPERATOR_SOURCES ${OPERATOR_SOURCES} csrc/cuda/*.h csrc/cuda/*.cu)
endif()

add_library(${PROJECT_NAME} SHARED ${OPERATOR_SOURCES})
target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES})
if (WITH_PYTHON)
  target_link_libraries(${PROJECT_NAME} PRIVATE Python3::Python)
endif()
set_target_properties(${PROJECT_NAME} PROPERTIES EXPORT_NAME TorchCluster)

target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${HEADERS}>"
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(TORCHCLUSTER_CMAKECONFIG_INSTALL_DIR "share/cmake/TorchCluster" CACHE STRING "install path for TorchClusterConfig.cmake")

configure_package_config_file(cmake/TorchClusterConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/TorchClusterConfig.cmake"
  INSTALL_DESTINATION ${TORCHCLUSTER_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/TorchClusterConfigVersion.cmake
  VERSION ${TORCHCLUSTER_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TorchClusterConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/TorchClusterConfigVersion.cmake
  DESTINATION ${TORCHCLUSTER_CMAKECONFIG_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
  EXPORT TorchClusterTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

install(EXPORT TorchClusterTargets
  NAMESPACE TorchCluster::
  DESTINATION ${TORCHCLUSTER_CMAKECONFIG_INSTALL_DIR})

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install(FILES
  csrc/cpu/fps_cpu.h
  csrc/cpu/graclus_cpu.h
  csrc/cpu/grid_cpu.h
  csrc/cpu/rw_cpu.h
  csrc/cpu/sampler_cpu.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cpu)
if(WITH_CUDA)
  install(FILES
    csrc/cuda/fps_cuda.h
    csrc/cuda/graclus_cuda.h
    csrc/cuda/grid_cuda.h
    csrc/cuda/knn_cuda.h
    csrc/cuda/nearest_cuda.h
    csrc/cuda/radius_cuda.h
    csrc/cuda/rw_cuda.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cuda)
endif()

if(WITH_CUDA)
  set_property(TARGET torch_cuda PROPERTY INTERFACE_COMPILE_OPTIONS "")
  set_property(TARGET torch_cpu PROPERTY INTERFACE_COMPILE_OPTIONS "")
endif()

=== debian/changelog ===
pytorch-cluster (1.6.3-2) unstable; urgency=medium

  * Team upload.
  * d/control: bump std-ver to 4.7.1 (no changes required)
  * d/rules: make dh_auto_clean more robust.
  * Rebuild for libtorch2.6 transition.

 -- Shengqi Chen <harry@debian.org>  Sun, 23 Feb 2025 23:57:36 +0800

pytorch-cluster (1.6.3-1) unstable; urgency=medium

  * New upstream version 1.6.3
  * Build on default only as python3-torch is built only there
    (Closes: #1058168)
  * Set upstream metadata fields: Repository.

 -- Andrius Merkys <merkys@debian.org>  Tue, 12 Dec 2023 03:57:52 -0500

pytorch-cluster (1.6.1-2) unstable; urgency=medium

  * Switch to Testsuite: autopkgtest-pkg-pybuild.
  * Binary package depends on python3-torch.

 -- Andrius Merkys <merkys@debian.org>  Tue, 03 Oct 2023 02:23:49 -0400

pytorch-cluster (1.6.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1052148)

 -- Andrius Merkys <merkys@debian.org>  Mon, 18 Sep 2023 03:45:44 -0400

=== debian/control ===
Source: pytorch-cluster
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 libtorch-dev,
 pybind11-dev,
 python3,
 python3-scipy <!nocheck>,
 python3-setuptools,
 python3-torch,
Testsuite: autopkgtest-pkg-pybuild
Standards-Version: 4.7.1
Homepage: https://github.com/rusty1s/pytorch_cluster
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-cluster
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-cluster.git

Package: python3-torch-cluster
Architecture: any
Multi-Arch: foreign
Depends:
 python3-torch,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: PyTorch extension library of optimized graph cluster algorithms (Python 3)
 This package consists of a small extension library of highly optimized graph
 cluster algorithms for the use in PyTorch. The package consists of the
 following clustering algorithms:
 .
  * Graclus from Dhillon et al.: Weighted Graph Cuts without Eigenvectors: A
    Multilevel Approach
  * Voxel Grid Pooling from, e.g., Simonovsky and Komodakis: Dynamic
    Edge-Conditioned Filters in Convolutional Neural Networks on Graphs
  * Iterative Farthest Point Sampling from, e.g. Qi et al.: PointNet++: Deep
    Hierarchical Feature Learning on Point Sets in a Metric Space
  * k-NN and Radius graph generation
  * Clustering based on nearest points
  * Random Walk Sampling from, e.g., Grover and Leskovec: node2vec: Scalable
    Feature Learning for Networks
 .
 All included operations work on varying data types and are implemented both
 for CPU and GPU.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = pytorch-cluster

export http_proxy = 127.0.0.1:9
export https_proxy = 127.0.0.1:9

%:
	dh $@ --buildsystem pybuild

override_dh_auto_clean:
	-dh_auto_clean
	-$(RM) -rf .pybuild/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/rusty1s/pytorch_cluster/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
